/* 
*
*  ProLinga-Run
*
*  Copyright (C) 2002-2009 Xobas Software.
*  All rights reserved.
*  
*  This file is part of ProLinga-Run.
*
*  ProLinga-Run is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  ProLinga-Run is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with ProLinga-Run.  If not, see <http://www.gnu.org/licenses/>.
*
*  More information is available at the following addresses:
*
*  Website     : http://www.prolinga.org
*
*  Email       : prolinga-list@prolinga.org
*
*
*/

#ifndef __BUILT_IN_HPP
#define __BUILT_IN_HPP

/* Type Definitions */
#define	BI_TYPE_NULL	0
#define	BI_TYPE_INT	1
#define	BI_TYPE_STRING	2


void ResetBuiltIns(void);

/* Built-In Definitions */

class BiAppn
{
	public:
		BiAppn();
		~BiAppn();
		char *getAppn();
		void setAppn(const char *application);
	private:
		char appn[32];
};
typedef BiAppn *BiAppnPtr;

class BiAppnDev
{
	public:
		BiAppnDev();
		~BiAppnDev();
		char *getAppnDev();
		void setAppnDev(const char *application);
	private:
		char appnDev[32];
};
typedef BiAppnDev *BiAppnDevPtr;

class CaDataSession
{
	public:
		CaDataSession();
		~CaDataSession();
		char *getDataSessionId(CaDataSession *caDataSesPtr, const char *dataSource);
		char *getExternalDataSource(CaDataSession *caDataSesPtr, const char *dataSource);
		void putDataSession(CaDataSession **caDataSesPtr, const char *session, const char *dataSource, const char *external);
		int deleteDataSession(CaDataSession **caDataSesPtr, const char *dataSource);
		void deleteList(CaDataSession **caDataSesPtr);
		void printList(CaDataSession *caDataSesPtr) const;
	private:
		char *sessionId;
		char *dataSourceName;
		char *extDataSource;
		CaDataSession *nextPtr;
};
typedef CaDataSession *CaDataSessionPtr;

class BiDataModelStatus
{
	public:
		BiDataModelStatus();
		~BiDataModelStatus();
		int getDataModelStatus();
		void setDataModelStatus(int status);
	private:
		int dataModelStatus;
};
typedef BiDataModelStatus *BiDataModelStatusPtr;

class BiErrorReturn
{
	public:
		BiErrorReturn();
		~BiErrorReturn();
		int getErrorReturn();
		void setErrorReturn(int error);
	private:
		int errorReturn;
};
typedef BiErrorReturn *BiErrorReturnPtr;

class BiValidateStatus
{
	public:
		BiValidateStatus();
		~BiValidateStatus();
		int getValidateStatus();
		void setValidateStatus(int status);
	private:
		int validateStatus;
};
typedef BiValidateStatus *BiValidateStatusPtr;

class BiRepositoryStatus
{
	public:
		BiRepositoryStatus();
		~BiRepositoryStatus();
		int getRepositoryStatus();
		void setRepositoryStatus(int status);
	private:
		int repositoryStatus;
};
typedef BiRepositoryStatus *BiRepositoryStatusPtr;

class BiTableStatus
{
	public:
		BiTableStatus();
		~BiTableStatus();
		int getTableStatus();
		void setTableStatus(int status);
	private:
		int tableStatus;
};
typedef BiTableStatus *BiTableStatusPtr;

class BiThreadExit
{
	public:
		BiThreadExit();
		~BiThreadExit();
		bool getThreadExit(pthread_t tid);
	private:

};
typedef BiThreadExit *BiThreadExitPtr;

class BiThreadStatus
{
	public:
		BiThreadStatus();
		~BiThreadStatus();
		int getThreadStatus();
		void setThreadStatus(int status);
	private:
		int threadStatus;
};
typedef BiThreadStatus *BiThreadStatusPtr;

class BiSqlInfo
{
	public:
		BiSqlInfo();
		~BiSqlInfo();
		char *getSqlInfo();
		void setSqlInfo(const char *info);
	private:
		char *sqlInfo;
};
typedef BiSqlInfo *BiSqlInfoPtr;

class BiSqlReturn
{
	public:
		BiSqlReturn();
		~BiSqlReturn();
		int getSqlReturn();
		void setSqlReturn(int returnVal);
	private:
		int sqlReturn;
};
typedef BiSqlReturn *BiSqlReturnPtr;

class BiSqlStatus
{
	public:
		BiSqlStatus();
		~BiSqlStatus();
		int getSqlStatus();
		void setSqlStatus(int status);
	private:
		int sqlStatus;
};
typedef BiSqlStatus *BiSqlStatusPtr;

class BiListColCount
{
	public:
		BiListColCount();
		~BiListColCount();
		int getListColCount(char *value);
	private:
};
typedef BiListColCount *BiListColCountPtr;

class BiListRowCount
{
	public:
		BiListRowCount();
		~BiListRowCount();
		int getListRowCount(char *value, bool isMainThread);
	private:
};
typedef BiListRowCount *BiListRowCountPtr;

class BiTextStatus
{
	public:
		BiTextStatus();
		~BiTextStatus();
		int getTextStatus();
		void setTextStatus(int status);
	private:
		int textStatus;
};
typedef BiTextStatus *BiTextStatusPtr;

class BiFalse
{
	public:
		BiFalse();
		~BiFalse();
		char *getFalse();
		void setFalse(char *value);
	private:
		char *falseValue;
};
typedef BiFalse *BiFalsePtr;

class BiTrue
{
	public:
		BiTrue();
		~BiTrue();
		char *getTrue();
		void setTrue(char *value);
	private:
		char *trueValue;
};
typedef BiTrue *BiTruePtr;

class BiXmlStatus
{
	public:
		BiXmlStatus();
		~BiXmlStatus();
		int getXmlStatus();
		void setXmlStatus(int status);
	private:
		int xmlStatus;
};
typedef BiXmlStatus *BiXmlStatusPtr;

class BiWebResponse
{
	public:
		BiWebResponse();
		~BiWebResponse();
		char *getWebResponse();
		void setWebResponse(char *response);
	private:
		char *webResponse;
};
typedef BiWebResponse *BiWebResponsePtr;

class BiWebParameter
{
	public:
		BiWebParameter();
		~BiWebParameter();
		char *getValue(BiWebParameter *biWebPtr, const char *name);
		void putValue(BiWebParameter **biWebPtr, const char *name, const char *value);
		void deleteList(BiWebParameter **biWebPtr);
		void printList(BiWebParameter *biWebPtr) const;
	private:
		char paramName[32];
		char *paramValue;
		BiWebParameter *nextPtr;
};
typedef BiWebParameter *BiWebParameterPtr;

class BiUser
{
	public:
		BiUser();
		~BiUser();
		char *getUser();
		void setUser(char *userName);
	private:
		char user[32];
};
typedef BiUser *BiUserPtr;

class BiQuitLastScreen
{
	public:
		BiQuitLastScreen();
		~BiQuitLastScreen();
		int getQuitLastScreen();
		void setQuitLastScreen(int setting);
	private:
		int quitLastScreenSetting;
};
typedef BiQuitLastScreen *BiQuitLastScreenPtr;


#endif /* __BUILT_IN_HPP */
