/* 
*
*  ProLinga-Run
*
*  Copyright (C) 2002-2009 Xobas Software.
*  All rights reserved.
*  
*  This file is part of ProLinga-Run.
*
*  ProLinga-Run is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  ProLinga-Run is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with ProLinga-Run.  If not, see <http://www.gnu.org/licenses/>.
*
*  More information is available at the following addresses:
*
*  Website     : http://www.prolinga.org
*
*  Email       : prolinga-list@prolinga.org
*
*
*/

#include "RunCommon.h"
#include "DataRef.hpp"
#include "Logic.hpp"
#include "Limits.hpp"

/* Current Parameter List */
extern ParameterPtr paramPtr;

/* Local variable (L-) */
extern DataDictionaryPtr dicPtr;

/* Command : PARAMETER */
/* Syntax  : PARAMETER local_variable [ local_variable ... ] */
void CmdParameter(const char **argList, int argHits, bool isMainThread)
{
	int i,j;
	char *paramValue;

	/* Get parameter values */
	j = paramPtr->countList(paramPtr);

	if (j != argHits)
	{
		printf("Argument - Parameter mismatch\n");
		exit(-1);
	}

	/* Get parameter names */
	for (i = 1; i <= argHits; i++)
	{
		/* Get value */
		paramValue = paramPtr->getValue(paramPtr, (i-1));

		/* Add value as local dictionary */
		dicPtr->putValue(&dicPtr, argList[i], 1, paramValue);
	}
}

