/* 
*
*  ProLinga-Run
*
*  Copyright (C) 2002-2008 Xobas Software.
*  All rights reserved.
*  
*  This file is part of ProLinga-Run.
*
*  ProLinga-Run is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  ProLinga-Run is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with ProLinga-Run.  If not, see <http://www.gnu.org/licenses/>.
*
*  More information is available at the following addresses:
*
*  Website     : http://www.prolinga.org
*
*  Email       : prolinga-list@prolinga.org
*
*
*/

#include "RunCommon.h"
#if BUILD_DATA
#include <prolinga/Data.hpp>
#endif
#if BUILD_REPOSITORY
#include <prolinga/Repository.hpp>
#endif
#if BUILD_VALIDATE
#include <prolinga/Validate.hpp>
#endif

#ifdef BUILD_DATA
extern PlDataPtr datRunPtr;
#endif
                                                                                                                                             
#ifdef BUILD_REPOSITORY
extern PlRepositoryPtr repRunPtr;
#endif
                                                                                                                                             
#ifdef BUILD_VALIDATE
extern PlValidatePtr valRunPtr;
#endif

void RunClose(void)
{

#ifdef BUILD_DATA
	/* Close Repository */
	datRunPtr->dataClose();
#endif

#ifdef BUILD_VALIDATE
	/* Close Validate */
	valRunPtr->validateClose();
#endif

#if defined(BUILD_REPOSITORY) && !defined(BUILD_VALIDATE)
	/* Close Repository */
	repRunPtr->repositoryClose();
#endif

}
